//
//  main.m
//  Dictionaries
//
//  Created by Holger Hinzberg on 27.03.11.
//  Copyright 2011 Cocoa-Coding. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Person.h"

int main (int argc, const char * argv[])
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    // 1.NSDictionary
    
    /* 
        
    // Einige Personen erzeugen
    Person *dicPer1 = [[Person alloc] init];
    dicPer1.name = @"Meier";
    
    Person *dicPer2 = [[Person alloc] init];
    dicPer2.name = @"Schmidt";
    
    Person *dicPer3 = [[Person alloc] init];
    dicPer3.name = @"Schuster";
    
    // Ein Dictionary erzeugen und die
    // Personen hinzufügen. Jedes Objekt benötig
    // einen Key, hier NSString, zur Identifizierung.
    NSDictionary *personenDictionary
    = [NSDictionary dictionaryWithObjectsAndKeys:
       dicPer1, @"Meier",
       dicPer2, @"Schmidt",
       dicPer3, @"Schuster",
       nil];
    
    [dicPer1 release];
    [dicPer2 release];
    [dicPer3 release];
    
    // Abfrage einer Person über den Key.
    Person *aDictPerson 
    = [personenDictionary objectForKey:@"Schmidt"];
    
    [aDictPerson sayYourName];
    
    */
    
    // 2.NSMutableDictionary
    
    // Ein Dictionary
    NSMutableDictionary *mutableDict
    = [NSMutableDictionary dictionary];
    
    Person *mDicPer1 = [[Person alloc] init];
    mDicPer1.name = @"Kaufmann";
    [mutableDict setObject:mDicPer1 forKey:@"Kaufmann"];
    [mDicPer1 release];
    
    Person *mDicPer2 = [[Person alloc] init];
    mDicPer2.name = @"Kellner";
    [mutableDict setObject:mDicPer2 forKey:@"Kellner"];
    [mDicPer2 release];  
    
    
    Person *mDicPer3 = [[Person alloc] init];
    mDicPer3.name = @"Krämer";
    
    // Objekt Krämer ersetzt Kaufmann durch Verwendung
    // des passenden Schlüssels.
    [mutableDict setObject:mDicPer3 forKey:@"Kaufmann"];
    [mDicPer3 release];
    
    for(id key in mutableDict)
    {
        [[mutableDict objectForKey:key] sayYourName];
    }
    
    [pool drain];
    return 0;
}

